// Bibliotheken zum Einbinden (Zufallszahlen, Ein-Ausgabe)
#include <cstdlib>
#include <stdio.h>
#include <iostream>
#include "hilf.h"
#include "vector.h"
#include "graphen.h"
#include "kuerzwege.h"
using namespace std;

// Das Hauptprogramm
int main()
{ const int nmax=100000;
  const int nnz=1000000; 
 
  int* column_indices;
  int* row_offsets;
  double* l;
  int* p;
  int n,ch,m,nz,m2,m1;
  double* entries;
  cout <<"Groesse des Gitters (axb)"<< endl;
  cin >> m1>> m2; 
 
  cout <<"MooreBellm.Ford(1), Dijkstra(2) oder BFS(3)"<< endl;  
  cin >> ch;
  n=m1*m2;
  nz=4*n; 
   column_indices=(int*)malloc(nz*sizeof(int));   
   row_offsets=(int*)malloc((n+1)*sizeof(int));   
   entries=(double*)malloc(nz*sizeof(double));   
   p=(int*)malloc(n*sizeof(int));   
   l=(double*)malloc(n*sizeof(double));  
   gitter(m1,m2,column_indices,entries,row_offsets);
   // Bestimme anzahl an Kanten
   m=row_offsets[n];
   if (ch<2)
     {  
      zufall(entries,m);
      MooreBellmannFord(n,0,column_indices,entries,
           row_offsets,p,l);  
     }
   else
     {
       if (ch<3)
       {
         zufall(entries,m);
         dijkstra(n,0,column_indices,entries,row_offsets,p,l); 
       }
       else
	 {
         BFS(n,0,column_indices,entries,row_offsets,p);
         }
     }
   ausgabeint(p,n);
   if (ch<3)
     { 
      ausgabe(l,n);
     }
   free(entries);
   free(column_indices);
   free(row_offsets);
   free(p);
   free(l);

  return 0;
}
